/*
 * Copyright © 2013 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *     Antti Kaijanmäki <antti.kaijanmaki@canonical.com>
 */

#ifndef COM_UBUNTU_CONNECTIVITY_NETWORKING_WIFI_ACCESS_POINT
#define COM_UBUNTU_CONNECTIVITY_NETWORKING_WIFI_ACCESS_POINT

#include <string>
#include <core/property.h>

namespace com {
namespace ubuntu {
namespace connectivity {
namespace networking {
namespace wifi {

class __attribute ((visibility ("default")))
AccessPoint
{
public:
    virtual ~AccessPoint() = default;

    /* from 0.00 to 100.00,
     *  -1 not available
     */
    virtual const core::Property<double>& strength() = 0;

    virtual std::string ssid() = 0;
    virtual bool secured()     = 0;
    virtual bool adhoc()       = 0;
};

}
}
}
}
}

#endif
