/*
 * Copyright © 2013 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *     Antti Kaijanmäki <antti.kaijanmaki@canonical.com>
 */

#ifndef COM_UBUNTU_CONNECTIVITY_NETWORKING_WIFI_LINK
#define COM_UBUNTU_CONNECTIVITY_NETWORKING_WIFI_LINK

#include <com/ubuntu/connectivity/networking/link.h>
#include <com/ubuntu/connectivity/networking/wifi/access-point.h>

#include <core/property.h>

#include <set>

namespace com {
namespace ubuntu {
namespace connectivity {
namespace networking {
namespace wifi {

class __attribute ((visibility ("default")))
Link : public com::ubuntu::connectivity::networking::Link
{
public:
    typedef unsigned int Id;

    Link() = default;
    Link(const Link&) = delete;
    virtual ~Link() = default;

    virtual const core::Property<std::set<std::shared_ptr<AccessPoint>>>& accessPoints() = 0;

    virtual void connect_to(std::shared_ptr<AccessPoint> accessPoint) = 0;

    virtual const core::Property<std::shared_ptr<AccessPoint>>& activeAccessPoint() = 0;

    virtual void request_scan() = 0;
};

}
}
}
}
}
 #endif
